# Notes:
#   - Find's #include statements and generate dependency list
#
#   Date			  Name		   Vers		Change
#	----------	 ------		   ----	-------------------------------
#	2009-02-22   chenyanlv	 1.0   Init Version
# ------------------------------------------------------------------------

use strict;
#use warnings;
use Cwd;
use File::Basename;

my $curpath;
my $path;
my %hsrcfile  = ();
my (@object);

sub CreateDir
{
	my ($path) = @_;
	my ($tmpPath) = $path.'/../';
		
	if (not -d "$tmpPath")
	{
		CreateDir($tmpPath);
	}
	
	if (not -d "$path")
	{
		mkdir "$path" or die "$!"; 
	}
}

sub CheckSrcFiles
{
	#read source files
	open(SRCFH,"$curpath\/MetaFile\/AllSrcFilsList.tbl")||die "$!\n";
	while(<SRCFH>)
	{
		chomp;
		my $npos;
		my $filepath;
		my $filetime;
		my $tmpfilename;
		
		$npos = index($_, '<>');
		if ($npos eq 0)
		{
			next;
		}
		
		$filepath = substr $_, 0, $npos;
		$filetime = substr $_, $npos+2;
		$tmpfilename = basename($filepath);
		$tmpfilename =~s/\.c|\.cpp|\.s/\.o/i;
		$hsrcfile{basename($tmpfilename)}=$filepath;
		
		if (not -f $filepath)
		{
			my @filelist = ($filepath);
			
			CreateDir(dirname($filepath));
			open (TMPSRCFH, ">$filepath") || die ("Could not open $filepath");
			close(TMPSRCFH);
			utime ($filetime, $filetime, @filelist);
		}
	}
	close(SRCFH);
	
	if ($ARGV[2] ne "") 
	{
		my $objlist;
		open(AOLFH, "$curpath\/MetaFile\/AllObjectsList.tbl")||die "$!\n";
		while(<AOLFH>)
		{
			chomp;
			$objlist = $objlist.$_;
		}
		close(AOLFH);
		@object = split(/ /,$objlist);
		
		foreach $path (@object)
		{
			$path = basename($path);
			if($path =~/\.o/i)
		  {
				if((not -f "$hsrcfile{$path}") or ((stat("$hsrcfile{$path}"))[7] == 0))
				{
					if($hsrcfile{$path} ne "")
					{
						print DEPFH "$hsrcfile{$path}\n";
					}
				}
			}
		}
	}
}

# ------------------------------------------------------------------------
# MAIN SCRIPT
#
# ------------------------------------------------------------------------

$curpath = $ARGV[0];

if (-f 'c:/MetaClientConfig.txt')
{
	system ("downloaddep.exe -list AllSrcFilsList.tbl $ARGV[1]");
}

if (not -d "$curpath\/MetaFile")
{
	mkdir ("$curpath\/MetaFile",0755)||warn "Failed to create:$!";
}
	
if (not -d "$curpath\/dep")
{
	mkdir ("$curpath\/dep",0755)||warn "Failed to create:$!";
}

open (DEPFH, ">$curpath\/MetaFile\/MissSrcList.tbl") || die ("Could not open $curpath\/MetaFile\/MissSrcList.tbl");
						
CheckSrcFiles();

close(DEPFH);

if ($ARGV[2] ne "") 
{
	if (-f 'c:/MetaClientConfig.txt')
	{
	 system ("downloaddep.exe -dep MissSrcList.tbl $ARGV[1]");
	}
}

1;