# ------------------------------------------------------------------------
#
#	inc_files_copy.pl
#
# Notes:
#   - Copy all include files
#   Date			  Name		Vers		Change
#	----------	 ------		----	-------------------------------
# 2006-04-05		tanrw		 1.0	 Init Version.
# ------------------------------------------------------------------------
use strict;
#use warnings;
use File::Copy;
use File::Basename;

my($incdir,$metafile)=@ARGV;

my (@Qincfiles,$Qincfiles);
my (@Metaincfiles,$Metaincfiles);
my @AllIncs;
my %IncFiles;
my( $name,$lcname, $path);

# --------------Main------------------------------------------------#
#create directory
if (not -d "$incdir")
{
		mkdir ("$incdir",0755)||warn "Failed to create:$!";
}
if (not -d "$incdir/msm")
{
		mkdir ("$incdir/msm",0755)||warn "Failed to create:$!";
}
if (not -d "$incdir/bid")
{
		mkdir ("$incdir/bid",0755)||warn "Failed to create:$!";
}
if (not -d "$incdir/ptclib")
{
		mkdir ("$incdir/ptclib",0755)||warn "Failed to create:$!";
}
if (not -d "$incdir/ptlib")
{
		mkdir ("$incdir/ptlib",0755)||warn "Failed to create:$!";
}

#read include files
open(INCFH,"$metafile\/Qincfiles.txt")||die "$!\n";
while(<INCFH>)
{
	chomp;
	$Qincfiles = $Qincfiles.$_;
}
close(INCFH);
@Qincfiles = split(/ /,$Qincfiles);
	
open(INCFH,"$metafile\/MetaFilesInc.txt")||die "$!\n";
while(<INCFH>)
{
	chomp;
	$Metaincfiles = $Metaincfiles.$_." ";
}
close(INCFH);
@Metaincfiles = split(/ /,$Metaincfiles);
	
@AllIncs = (@Qincfiles,@Metaincfiles);
	
foreach (@AllIncs)
{
	chomp;
	$name= basename($_);
	$lcname = lc($name);
	$path= dirname($_);
	if((exists $IncFiles{$lcname}) and (lc($IncFiles{$lcname}) ne lc($_)))
	{
		my $prev_path = dirname($IncFiles{$lcname});
		print "#Replace $name\n";
		print "#   --From: $prev_path\n";
		print "#   --To:   $path\n";
	}
	$IncFiles{$lcname}=$_;
		
	my $mtime = (stat("$_"))[9];
	my $mtime_exist = (stat("$incdir/$name"))[9];
		
	#if $name is not exist or is modified,copy it
  if ((not -f "$incdir/$name") or ($mtime ne $mtime_exist))
  { 	
		copy ("$_","$incdir");
		system("attrib -R $incdir/$name");
    if(/\/bid\//i)              #/bid/
    {
    	copy ("$_","$incdir/bid");
    	system("attrib -R $incdir/bid/$name");
    }
    elsif(/\/msm\//i)           #/msm/
    {
    	copy ("$_","$incdir/msm");
    	system("attrib -R $incdir/msm/$name");
    }
    elsif(/\/ptclib\//i)        #/ptclib/
    {
    	copy ("$_","$incdir/ptclib");
    	system("attrib -R $incdir/ptclib/$name");
    }
    elsif(/\/ptlib\//i)         #/ptlib/
    {
    	copy ("$_","$incdir/ptlib");
    	system("attrib -R $incdir/ptlib/$name");
    }
   }
}
